Index: .bzrignore
===================================================================
--- .bzrignore	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ .bzrignore	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -2,4 +2,13 @@
 config.h
 bitlbee
+Debug
+Debugx
+deps
+admin/Debug
+admin/admin.plg
+bitlbee.plg
+*.plg
+*.aps
+*.clw
 user-guide.txt
 user-guide.html
Index: Makefile
===================================================================
--- Makefile	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ Makefile	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -10,6 +10,12 @@
 
 # Program variables
-objects = account.o bitlbee.o conf.o crypting.o help.o ini.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_text.o unix.o url.o user.o util.o
+objects = account.o bitlbee.o crypting.o help.o ini.o ipc.o irc.o irc_commands.o nick.o query.o root_commands.o set.o storage.o storage_text.o url.o user.o util.o
 subdirs = protocols
+
+ifeq ($(ARCH),Windows)
+objects += win32.o
+else
+objects += unix.o conf.o log.o
+endif
 
 # Expansion of variables
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ bitlbee.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -141,7 +141,4 @@
 		return( 1 );
 	
-	log_link( LOGLVL_ERROR, LOGOUTPUT_IRC );
-	log_link( LOGLVL_WARNING, LOGOUTPUT_IRC );
-	
 	return( 0 );
 }
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ bitlbee.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -48,7 +48,8 @@
 #include <stdio.h>
 #include <ctype.h>
+#include <errno.h>
+
 #ifndef _WIN32
 #include <syslog.h>
-#include <errno.h>
 #endif
 
@@ -75,8 +76,4 @@
 #undef strncasecmp
 #define strncasecmp	__PLEASE_USE_G_STRNCASECMP_INSTEAD__
-
-#ifndef F_OK
-#define F_OK 0
-#endif
 
 #define _( x ) x
Index: configure
===================================================================
--- configure	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ configure	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -62,5 +62,5 @@
 --ipv6=0/1	IPv6 socket support			$ipv6
 
---ssl=...	SSL library to use (gnutls, nss, openssl, bogus, auto)
+--ssl=...	SSL library to use (gnutls, nss, openssl, sspi, bogus, auto)
 							$ssl
 EOF
@@ -225,4 +225,6 @@
 	elif [ "$ssl" = "nss" ]; then
 		detect_nss;
+	elif [ "$ssl" = "sspi" ]; then
+		echo
 	elif [ "$ssl" = "openssl" ]; then
 		echo
Index: doc/BUILD.win32
===================================================================
--- doc/BUILD.win32	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ doc/BUILD.win32	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,35 @@
+Instructions for building BitlBee on Windows 
+================================================
+
+1. Download the latest version using bzr (http://www.bazaar-ng.org/):
+
+   H:\> bzr branch http://win32.bitlbee.org/bzr bitlbee-win32
+   ...
+
+2. Download and install the required development files: 
+    from ftp://ftp.gtk.org/pub/gtk/v2.8/win32/
+    - glib
+    - glib-dev
+    - libiconv (in dependencies/)
+    - gettext (in dependencies/)
+    from http://ftp.mozilla.org/pub/mozilla.org/
+    - nss (in security/nss/)
+    - nspr (in nspr/)
+
+  glib and gettext are only required for actually running BitlBee - building
+  should work fine without them.
+
+3. Set the following variables in Makefile.settings, if you don't have the 
+   libraries above installed in the default directories searched by MSVC:
+
+   - GLIB_DIR
+   - NSS_DIR
+   - NSPR_DIR
+
+4. Build:
+
+	H:\BitlBee> nmake /f win32.mk
+	...
+
+5. To build setup files, compile the bitlbee.iss file using the Inno Setup 
+   program (available from www.jrsoftware.org).
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ protocols/nogaim.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -159,4 +159,23 @@
 	irc_t *irc;
 };
+
+struct ft 
+{
+	const char *filename;
+	
+	/* Total number of bytes in file */
+	size_t total_bytes;
+	
+	/* Current number of bytes received */
+	size_t cur_bytes;
+};
+
+struct ft_request 
+{
+	const char *filename;
+	struct gaim_connection *gc;
+};
+
+typedef void (*ft_recv_handler) (struct ft *, void *data, size_t len);
 
 struct prpl {
@@ -215,4 +234,9 @@
 	void (* group_buddy)	(struct gaim_connection *, char *who, char *old_group, char *new_group);
 
+	/* file transfers */
+	struct ft_send_req *(* req_send_file) (struct gaim_connection *, const char *file);
+	void (* send_file_part) (struct gaim_connection *, struct ft*, void *data, size_t length);
+	void (* accept_recv_file) (struct gaim_connection *, struct ft*, ft_recv_handler);
+
 	void (* buddy_free)	(struct buddy *);
 
Index: protocols/ssl_sspi.c
===================================================================
--- protocols/ssl_sspi.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ protocols/ssl_sspi.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,210 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* SSL module - SSPI backend */
+
+/* Copyright (C) 2005 Jelmer Vernooij <jelmer@samba.org> */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "ssl_client.h"
+#include <windows.h>
+#define SECURITY_WIN32
+#include <security.h>
+#include <sspi.h>
+#include <schannel.h>
+
+static gboolean initialized = FALSE;
+int ssl_errno;
+
+struct scd
+{
+	int fd;
+	SslInputFunction func;
+	gpointer data;
+	gboolean established;
+	int inpa;
+  	CredHandle cred;		/* SSL credentials */
+	CtxtHandle context;		/* SSL context */
+	SecPkgContext_StreamSizes sizes;
+};
+
+static void ssl_connected( gpointer data, gint source, GaimInputCondition cond );
+
+void sspi_global_init( void )
+{
+	/* FIXME */
+}
+
+void sspi_global_deinit( void )
+{
+	/* FIXME */
+}
+
+void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data )
+{
+	struct scd *conn = g_new0( struct scd, 1 );
+	SCHANNEL_CRED ssl_cred;
+	TimeStamp timestamp;
+	
+	conn->fd = proxy_connect( host, port, ssl_connected, conn );
+	conn->func = func;
+	conn->data = data;
+	conn->inpa = -1;
+	
+	if( conn->fd < 0 )
+	{
+		g_free( conn );
+		return( NULL );
+	}
+	
+	if( !initialized )
+	{
+		sspi_global_init();
+		initialized = TRUE;
+		atexit( sspi_global_deinit );
+	}
+
+	conn->context = NULL;
+
+	memset(&ssl_cred, 0, sizeof(SCHANNEL_CRED));
+	ssl_cred.dwVersion = SCHANNEL_CRED_VERSION;
+	ssl_cred.grbitEnabledProtocols = SP_PROT_SSL3_CLIENT;
+
+	SECURITY_STATUS st = AcquireCredentialsHandle(NULL, UNISP_NAME, SECPKG_CRED_OUTBOUND, NULL, &ssl_cred, NULL, NULL, &conn->cred, &timestamp);
+	
+	InitializeSecurityContext(&conn->cred, &conn->context, host, FIXME, 1, FIXME);  
+
+	QueryContextAttributes(&conn->context, SECPKG_ATTR_STREAM_SIZES, &conn->sizes);
+
+	
+	return( conn );
+}
+
+int ssl_read( void *conn, char *retdata, int len )
+{
+	struct scd *scd = conn;
+	SecBufferDesc msg;
+	SecBuffer buf[4];
+	int ret = -1, i;
+	char *data = g_malloc(scd->sizes.cbHeader + scd->sizes.cbMaximumMessage + scd->sizes.cbTrailer);
+
+	/* FIXME: Try to read some data */
+
+  	msg.ulVersion = SECBUFFER_VERSION;
+	msg.cBuffers = 4;
+	msg.pBuffers = buf;
+	
+	buf[0].BufferType = SECBUFFER_DATA;
+	buf[0].cbBuffer = len;
+	buf[0].pvBuffer = data;
+
+	buf[1].BufferType = SECBUFFER_EMPTY;
+	buf[2].BufferType = SECBUFFER_EMPTY;
+	buf[3].BufferType = SECBUFFER_EMPTY;
+
+	SECURITY_STATUS st = DecryptMessage(&scd->context, &msg, 0, NULL);
+
+	for (i = 0; i < 4; i++) {
+		if (buf[i].BufferType == SECBUFFER_DATA) {
+			memcpy(retdata, buf[i].pvBuffer, len);
+			ret = len;
+		}	
+	}
+
+	g_free(data);
+	return( -1 );
+}
+
+int ssl_write( void *conn, const char *userdata, int len )
+{
+	struct scd *scd = conn;
+	SecBuffer buf[4];
+	SecBufferDesc msg;
+	char *data;
+	int ret;
+
+	msg.ulVersion = SECBUFFER_VERSION;
+	msg.cBuffers = 4;
+	msg.pBuffers = buf;
+
+	data = g_malloc(scd->sizes.cbHeader + scd->sizes.cbMaximumMessage + scd->sizes.cbTrailer);
+	memcpy(data + scd->sizes.cbHeader, userdata, len);
+
+	buf[0].BufferType = SECBUFFER_STREAM_HEADER;
+	buf[0].cbBuffer = scd->sizes.cbHeader;
+	buf[0].pvBuffer = data;
+
+	buf[1].BufferType = SECBUFFER_DATA;
+	buf[1].cbBuffer = len;
+	buf[1].pvBuffer = data + scd->sizes.cbHeader;
+
+	buf[2].BufferType = SECBUFFER_STREAM_TRAILER;
+	buf[2].cbBuffer = scd->sizes.cbTrailer;
+	buf[2].pvBuffer = data + scd->sizes.cbHeader + len;
+	buf[3].BufferType = SECBUFFER_EMPTY;
+
+	SECURITY_STATUS st = EncryptMessage(&scd->context, 0, &msg, 0);
+
+	ret = send(scd->fd, data, 
+				buf[0].cbBuffer + buf[1].cbBuffer + buf[2].cbBuffer, 0);
+
+	g_free(data);
+
+	return ret;
+}
+
+void ssl_disconnect( void *conn )
+{
+	struct scd *scd = conn;
+
+	SecBufferDesc msg;
+	SecBuffer buf;
+	DWORD dw;
+
+	dw = SCHANNEL_SHUTDOWN;
+	buf.cbBuffer = sizeof(dw);
+	buf.BufferType = SECBUFFER_TOKEN;
+	buf.pvBuffer = &dw;
+	
+	msg.ulVersion = SECBUFFER_VERSION;
+	msg.cBuffers = 1;
+	msg.pBuffers = &buf;
+
+	SECURITY_STATUS st = ApplyControlToken(&scd->context, &msg);
+
+	if (st != SEC_E_OK) {
+		/* FIXME */
+	}
+	
+	/* FIXME: call InitializeSecurityContext(Schannel), passing 
+	 * in empty buffers*/
+
+	DeleteSecurityContext(&scd->context);
+
+	closesocket( scd->fd );
+	g_free(scd);
+}
+
+int ssl_getfd( void *conn )
+{
+	return( ((struct scd*)conn)->fd );
+}
Index: sock.h
===================================================================
--- sock.h	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ sock.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -21,7 +21,4 @@
 #else
 # include <winsock2.h>
-# ifndef _MSC_VER
-#  include <ws2tcpip.h>
-# endif
 # if !defined(BITLBEE_CORE) && defined(_MSC_VER)
 #   pragma comment(lib,"bitlbee.lib")
@@ -30,6 +27,4 @@
 # define read(a,b,c) recv(a,b,c,0)
 # define write(a,b,c) send(a,b,c,0)
-# define umask _umask
-# define mode_t int
 # define sock_make_nonblocking(fd) { int non_block = 1; ioctlsocket(fd, FIONBIO, &non_block); }
 # define sock_make_blocking(fd) { int non_block = 0; ioctlsocket(fd, FIONBIO, &non_block); }
Index: storage_text.c
===================================================================
--- storage_text.c	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ storage_text.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -27,4 +27,12 @@
 #include "bitlbee.h"
 #include "crypting.h"
+#ifdef _WIN32
+# define umask _umask
+# define mode_t int
+#endif
+
+#ifndef F_OK
+#define F_OK 0
+#endif
 
 /* DO NOT USE THIS FUNCTION IN NEW CODE. This 
Index: unix.c
===================================================================
--- unix.c	(revision 9a1555dc8521f0973347911bcb26d1038259f967)
+++ unix.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -64,4 +64,7 @@
 	if( global.conf->runmode == RUNMODE_INETD )
 	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_IRC );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_IRC );
+	
 		i = bitlbee_inetd_init();
 		log_message( LOGLVL_INFO, "Bitlbee %s starting in inetd mode.", BITLBEE_VERSION );
@@ -70,4 +73,7 @@
 	else if( global.conf->runmode == RUNMODE_DAEMON )
 	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+
 		i = bitlbee_daemon_init();
 		log_message( LOGLVL_INFO, "Bitlbee %s starting in daemon mode.", BITLBEE_VERSION );
Index: win32.c
===================================================================
--- win32.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ win32.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,315 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Main file (Windows specific part)                                   */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "bitlbee.h"
+#include "commands.h"
+#include "crypting.h"
+#include "protocols/nogaim.h"
+#include "help.h"
+#include <signal.h>
+#include <windows.h>
+
+global_t global;	/* Against global namespace pollution */
+
+static void WINAPI service_ctrl (DWORD dwControl)
+{
+	switch (dwControl)
+	{
+        case SERVICE_CONTROL_STOP:
+			/* FIXME */
+            break;
+
+        case SERVICE_CONTROL_INTERROGATE:
+            break;
+
+        default:
+            break;
+
+    }
+}
+
+static void bitlbee_init(int argc, char **argv)
+{
+	int i = -1;
+	memset( &global, 0, sizeof( global_t ) );
+	
+	global.loop = g_main_new( FALSE );
+	
+	global.conf = conf_load( argc, argv );
+	if( global.conf == NULL )
+		return;
+	
+	if( global.conf->runmode == RUNMODE_INETD )
+	{
+		i = bitlbee_inetd_init();
+		log_message( LOGLVL_INFO, "Bitlbee %s starting in inetd mode.", BITLBEE_VERSION );
+
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		i = bitlbee_daemon_init();
+		log_message( LOGLVL_INFO, "Bitlbee %s starting in daemon mode.", BITLBEE_VERSION );
+	} 
+	else 
+	{
+		log_message( LOGLVL_INFO, "No bitlbee mode specified...");
+	}
+	
+	if( i != 0 )
+		return;
+ 	
+	if( access( global.conf->configdir, F_OK ) != 0 )
+		log_message( LOGLVL_WARNING, "The configuration directory %s does not exist. Configuration won't be saved.", global.conf->configdir );
+	else if( access( global.conf->configdir, 06 ) != 0 )
+		log_message( LOGLVL_WARNING, "Permission problem: Can't read/write from/to %s.", global.conf->configdir );
+	if( help_init( &(global.help) ) == NULL )
+		log_message( LOGLVL_WARNING, "Error opening helpfile %s.", global.helpfile );
+}
+
+void service_main (DWORD argc, LPTSTR *argv)
+{
+	SERVICE_STATUS_HANDLE handle;
+	SERVICE_STATUS status;
+
+    handle = RegisterServiceCtrlHandler("bitlbee", service_ctrl);
+
+    if (!handle)
+		return;
+
+    status.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
+    status.dwServiceSpecificExitCode = 0;
+
+	bitlbee_init(argc, argv);
+
+	SetServiceStatus(handle, &status);
+	
+	g_main_run( global.loop );
+}
+
+SERVICE_TABLE_ENTRY dispatch_table[] =
+{
+   { TEXT("bitlbee"), (LPSERVICE_MAIN_FUNCTION)service_main },
+   { NULL, NULL }
+};
+
+static int debug = 0;
+
+static void usage()
+{
+	printf("Options:\n");
+	printf("-h   Show this help message\n");
+	printf("-d   Debug mode (simple console program)\n");
+}
+
+int main( int argc, char **argv)
+{    
+	int i;
+	WSADATA WSAData;
+
+	nogaim_init( );
+
+	for (i = 1; i < argc; i++) {
+		if (!strcmp(argv[i], "-d")) debug = 1;
+		if (!strcmp(argv[i], "-h")) {
+			usage();
+			return 0;
+		}
+	}
+
+    WSAStartup(MAKEWORD(1,1), &WSAData);
+
+	if (!debug) {
+		if (!StartServiceCtrlDispatcher(dispatch_table))
+			log_message( LOGLVL_ERROR, "StartServiceCtrlDispatcher failed.");
+	} else {
+			bitlbee_init(argc, argv);
+ 			g_main_run( global.loop );
+	}
+	
+	return 0;
+}
+
+double gettime()
+{
+	return (GetTickCount() / 1000);
+}
+
+void conf_get_string(HKEY section, const char *name, const char *def, char **dest)
+{
+	char buf[4096];
+	long x;
+	if (RegQueryValue(section, name, buf, &x) == ERROR_SUCCESS) {
+		*dest = g_strdup(buf);
+	} else if (!def) {
+		*dest = NULL;
+	} else {
+		*dest = g_strdup(def);
+	}
+}
+
+
+void conf_get_int(HKEY section, const char *name, int def, int *dest)
+{
+	char buf[20];
+	long x;
+	DWORD y;
+	if (RegQueryValue(section, name, buf, &x) == ERROR_SUCCESS) {
+		memcpy(&y, buf, sizeof(DWORD));
+		*dest = y;
+	} else {
+		*dest = def;
+	}
+}
+
+conf_t *conf_load( int argc, char *argv[] ) 
+{
+	conf_t *conf;
+	HKEY key, key_main, key_proxy;
+	char *tmp;
+
+	RegOpenKey(HKEY_CURRENT_USER, "SOFTWARE\\Bitlbee", &key);
+	RegOpenKey(key, "main", &key_main);
+	RegOpenKey(key, "proxy", &key_proxy);
+	
+	memset( &global, 0, sizeof( global_t ) );
+	global.loop = g_main_new(FALSE);
+
+	conf = g_new0( conf_t,1 );
+	global.conf = conf;
+	conf_get_string(key_main, "interface", "0.0.0.0", &global.conf->iface);
+	conf_get_int(key_main, "port", 6667, &global.conf->port);
+	conf_get_int(key_main, "verbose", 0, &global.conf->verbose);
+	conf_get_string(key_main, "password", "", &global.conf->password);
+	conf_get_int(key_main, "ping_interval_timeout", 60, &global.conf->ping_interval);
+	conf_get_string(key_main, "hostname", "localhost", &global.conf->hostname);
+	conf_get_string(key_main, "configdir", NULL, &global.conf->configdir);
+	conf_get_string(key_main, "motdfile", NULL, &global.conf->motdfile);
+	conf_get_string(key_main, "helpfile", NULL, &global.helpfile);
+	global.conf->runmode = RUNMODE_DAEMON;
+	conf_get_int(key_main, "AuthMode", AUTHMODE_OPEN, &global.conf->authmode);
+	conf_get_string(key_proxy, "host", "", &tmp); strcpy(proxyhost, tmp);
+	conf_get_string(key_proxy, "user", "", &tmp); strcpy(proxyuser, tmp);
+	conf_get_string(key_proxy, "password", "", &tmp); strcpy(proxypass, tmp);
+	conf_get_int(key_proxy, "type", PROXY_NONE, &proxytype);
+	conf_get_int(key_proxy, "port", 3128, &proxyport);
+
+	RegCloseKey(key);
+	RegCloseKey(key_main);
+	RegCloseKey(key_proxy);
+
+	return conf;
+}
+
+void conf_loaddefaults( irc_t *irc )
+{
+	HKEY key_defaults;
+	int i;
+	char name[4096], data[4096];
+	DWORD namelen = sizeof(name), datalen = sizeof(data);
+	DWORD type;
+	if (RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Bitlbee\\defaults", &key_defaults) != ERROR_SUCCESS) {
+		return;
+	}
+
+	for (i = 0; RegEnumValue(key_defaults, i, name, &namelen, NULL, &type, data, &datalen) == ERROR_SUCCESS; i++) {
+		set_t *s = set_find( irc, name );
+			
+		if( s )
+		{
+			if( s->def ) g_free( s->def );
+			s->def = g_strdup( data );
+		}
+
+		namelen = sizeof(name);
+		datalen = sizeof(data);
+	}
+
+	RegCloseKey(key_defaults);
+}
+
+#ifndef INADDR_NONE
+#define INADDR_NONE 0xffffffff
+#endif
+
+int
+inet_aton(const char *cp, struct in_addr *addr)
+{
+  addr->s_addr = inet_addr(cp);
+  return (addr->s_addr == INADDR_NONE) ? 0 : 1;
+}
+
+void log_error(char *msg)
+{
+	log_message(LOGLVL_ERROR, "%s", msg);
+}
+
+void log_message(int level, char *message, ...)
+{
+    HANDLE  hEventSource;
+    LPTSTR  lpszStrings[2];
+	WORD elevel;
+    va_list ap;
+
+    va_start(ap, message);
+
+	if (debug) {
+		vprintf(message, ap);
+		putchar('\n');
+		va_end(ap);
+		return;
+	}
+
+    hEventSource = RegisterEventSource(NULL, TEXT("bitlbee"));
+
+    lpszStrings[0] = TEXT("bitlbee");
+    lpszStrings[1] = g_strdup_vprintf(message, ap);
+    va_end(ap);
+
+	switch (level) {
+	case LOGLVL_ERROR: elevel = EVENTLOG_ERROR_TYPE; break;
+	case LOGLVL_WARNING: elevel = EVENTLOG_WARNING_TYPE; break;
+	case LOGLVL_INFO: elevel = EVENTLOG_INFORMATION_TYPE; break;
+#ifdef DEBUG
+	case LOGLVL_DEBUG: elevel = EVENTLOG_AUDIT_SUCCESS; break;
+#endif
+	}
+
+    if (hEventSource != NULL) {
+        ReportEvent(hEventSource, 
+        elevel,
+        0,                    
+        0,                    
+        NULL,                 
+        2,                    
+        0,                    
+        lpszStrings,          
+        NULL);                
+
+        DeregisterEventSource(hEventSource);
+    }
+
+	g_free(lpszStrings[1]);
+}
Index: win32.mk
===================================================================
--- win32.mk	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ win32.mk	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,136 @@
+!INCLUDE Makefile.settings
+
+GLIB_CFLAGS = /I "$(GLIB_DIR)\include" \
+	      /I "$(GLIB_DIR)\include\glib-2.0" \
+	      /I "$(GLIB_DIR)\lib\glib-2.0\include"
+
+GLIB_LFLAGS = /libpath:"$(GLIB_DIR)\lib" 
+
+NSS_CFLAGS = /I "$(NSS_DIR)\include" /I "$(NSPR_DIR)\include"
+NSS_LFLAGS = /libpath:"$(NSS_DIR)\lib" /libpath:"$(NSPR_DIR)\lib" 
+NSS_LIBS = nss3.lib ssl3.lib libnspr4.lib
+
+COMMON_LIBS = kernel32.lib user32.lib advapi32.lib shell32.lib iconv.lib \
+			glib-2.0.lib gmodule-2.0.lib wsock32.lib advapi32.lib 
+
+
+MAIN_OBJS = account.obj bitlbee.obj commands.obj crypting.obj \
+	help.obj irc.obj protocols\md5.obj protocols\nogaim.obj \
+	protocols\sha.obj protocols\proxy.obj query.obj nick.obj set.obj \
+	user.obj protocols\util.obj win32.obj 
+
+MAIN_LIBS = $(COMMON_LIBS)
+
+SSL_OBJS = protocols\ssl_nss.obj
+SSL_LIBS = $(NSS_LFLAGS) $(NSS_LIBS)
+
+MSN_OBJS = \
+	protocols\msn\msn.obj \
+	protocols\msn\msn_util.obj \
+	protocols\msn\ns.obj \
+	protocols\msn\passport.obj \
+	protocols\msn\sb.obj \
+	protocols\msn\tables.obj \
+	$(SSL_OBJS)
+
+MSN_LIBS = $(COMMON_LIBS) $(SSL_LIBS)
+
+OSCAR_OBJS = \
+	protocols\oscar\admin.obj \
+	protocols\oscar\auth.obj \
+	protocols\oscar\bos.obj \
+	protocols\oscar\buddylist.obj \
+	protocols\oscar\chat.obj \
+	protocols\oscar\chatnav.obj \
+	protocols\oscar\conn.obj \
+	protocols\oscar\icq.obj \
+	protocols\oscar\im.obj \
+	protocols\oscar\info.obj \
+	protocols\oscar\misc.obj \
+	protocols\oscar\msgcookie.obj \
+	protocols\oscar\oscar.obj \
+	protocols\oscar\oscar_util.obj \
+	protocols\oscar\rxhandlers.obj \
+	protocols\oscar\rxqueue.obj \
+	protocols\oscar\search.obj \
+	protocols\oscar\service.obj \
+	protocols\oscar\snac.obj \
+	protocols\oscar\ssi.obj \
+	protocols\oscar\stats.obj \
+	protocols\oscar\tlv.obj \
+	protocols\oscar\txqueue.obj
+
+OSCAR_LIBS = $(COMMON_LIBS)
+
+JABBER_OBJS = \
+	protocols\jabber\expat.obj \
+	protocols\jabber\genhash.obj \
+	protocols\jabber\hashtable.obj \
+	protocols\jabber\jabber.obj \
+	protocols\jabber\jconn.obj \
+	protocols\jabber\jid.obj \
+	protocols\jabber\jpacket.obj \
+	protocols\jabber\jutil.obj \
+	protocols\jabber\karma.obj \
+	protocols\jabber\log.obj \
+	protocols\jabber\pool.obj \
+	protocols\jabber\pproxy.obj \
+	protocols\jabber\rate.obj \
+	protocols\jabber\str.obj \
+	protocols\jabber\xhash.obj \
+	protocols\jabber\xmlnode.obj \
+	protocols\jabber\xmlparse.obj \
+	protocols\jabber\xmlrole.obj \
+	protocols\jabber\xmltok.obj \
+	protocols\jabber\xstream.obj \
+	$(SSL_OBJS)
+
+JABBER_LIBS = $(COMMON_LIBS) $(SSL_LIBS)
+
+YAHOO_OBJS = \
+	protocols\yahoo\crypt.obj \
+	protocols\yahoo\libyahoo2.obj \
+	protocols\yahoo\vc50.idb \
+	protocols\yahoo\yahoo.obj \
+	protocols\yahoo\yahoo_fn.obj \
+	protocols\yahoo\yahoo_httplib.obj \
+	protocols\yahoo\yahoo_list.obj \
+	protocols\yahoo\yahoo_util.obj
+
+YAHOO_LIBS = $(COMMON_LIBS)
+
+CC=cl.exe
+CFLAGS=$(GLIB_CFLAGS) $(NSS_CFLAGS) /D NDEBUG /D WIN32 /D _WINDOWS \
+       /I . /I protocols /I protocols\oscar /nologo \
+       /D GLIB2 /D ARCH="\"Windows\"" /D CPU="\"x86\"" \
+       /D PLUGINDIR="plugins"
+
+.c.obj:
+	$(CC) $(CFLAGS) /c /Fo$@ $<
+
+ALL: bitlbee.exe libmsn.dll liboscar.dll libjabber.dll libyahoo.dll
+	
+LINK32=link.exe
+LINK32_FLAGS=/nologo $(GLIB_LFLAGS)
+
+bitlbee.exe: $(DEF_FILE) $(MAIN_OBJS)
+    $(LINK32) $(MAIN_LIBS) $(LINK32_FLAGS) /out:bitlbee.exe $(MAIN_OBJS)
+
+libmsn.dll: $(MSN_OBJS) 
+	$(LINK32) /DLL /SUBSYSTEM:WINDOWS /ENTRY:msn_init $(MSN_LIBS) $(LINK32_FLAGS) /out:libmsn.dll $(MSN_OBJS)
+
+libyahoo.dll: $(YAHOO_OBJS)
+	$(LINK32) /DLL /SUBSYSTEM:WINDOWS /ENTRY:yahoo_init $(YAHOO_LIBS) $(LINK32_FLAGS) /out:libyahoo.dll $(YAHOO_OBJS)
+
+liboscar.dll: $(OSCAR_OBJS)
+	$(LINK32) /DLL /SUBSYSTEM:WINDOWS /ENTRY:oscar_init $(OSCAR_LIBS) $(LINK32_FLAGS) /out:liboscar.dll $(OSCAR_OBJS)
+
+libjabber.dll: $(JABBER_OBJS)
+	$(LINK32) /DLL /SUBSYSTEM:WINDOWS /ENTRY:jabber_init $(JABBER_LIBS) $(LINK32_FLAGS) /out:libjabber.dll $(JABBER_OBJS)
+
+clean:
+	@-erase $(MAIN_OBJS)
+	@-erase $(MSN_OBJS)
+	@-erase $(JABBER_OBJS)
+	@-erase $(OSCAR_OBJS)
+	@-erase $(YAHOO_OBJS)
